Unit MLA1R2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLA1R2(var A :Array of Real; M :Integer; N :Integer;
                MA :Integer; NA :Integer; var L2 :Array of Integer;
                NL2 :Integer; var IP :Integer; KP :Integer;
                var Q1 :Real);

implementation

procedure MLA1R2(var A :Array of Real; M :Integer; N :Integer;
                MA :Integer; NA :Integer; var L2 :Array of Integer;
                NL2 :Integer; var IP :Integer; KP :Integer;
                var Q1 :Real);
var
I,II,I1,I11,K :Integer;
Q,QP,QO :Real;
const
EPS :Real = 1.0E-6;
label
_10,_20,_30,_40,_50,_60,_70;
begin
IP := 0;
if ( NL2 < 1 ) 
 then goto _70;
for I:=1 to NL2 do
 begin
  IP := L2[I-1];
  I1 := I;
  if ( A[(IP+0)+(KP+0)*MA] < -EPS ) 
   then goto _20;
_10:
 end;
goto _70;
_20:
Q1 := -A[(IP+0)+0*MA]/A[(IP+0)+(KP+0)*MA];
if ( I1+1 > NL2 ) 
 then goto _70;
I11 := I1+1;
for I:=I11 to NL2 do
 begin
  II := L2[I-1];
  if ( A[(II+0)+(KP+0)*MA] >= -EPS ) 
   then goto _60;
  Q := -A[(II+0)+0*MA]/A[(II+0)+(KP+0)*MA];
  if ( Q >= Q1 ) 
   then goto _30;
  IP := II;
  Q1 := Q;
  goto _60;
_30:
  if ( Q > Q1 ) 
   then goto _60;
  for K:=1 to N do
   begin
    QP := -A[(IP+0)+(K+0)*MA]/A[(IP+0)+(KP+0)*MA];
    QO := -A[(II+0)+(K+0)*MA]/A[(II+0)+(KP+0)*MA];
    if ( QO <> QP ) 
     then goto _50;
_40:
   end;
_50:
  if ( QO < QP ) 
   then IP := II;
_60:
 end;
_70:
end;

end.
