Unit MLA1R3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLA1R3(var A :Array of Real; MA :Integer; NA :Integer;
                I1 :Integer; K1 :Integer; IP :Integer; KP :Integer);

implementation

procedure MLA1R3(var A :Array of Real; MA :Integer; NA :Integer;
                I1 :Integer; K1 :Integer; IP :Integer; KP :Integer);
var
I11,II,K11,KK :Integer;
PIV :Real;
const
ONE :Real = 1.0;
label
_10,_20,_30,_40;
begin
K11 := K1+1;
PIV := ONE/A[(IP+0)+(KP+0)*MA];
if ( I1 < 0 ) 
 then goto _30;
I11 := I1+1;
for II:=1 to I11 do
 begin
  if ( II-1 = IP ) 
   then goto _20;
  A[(II-1)+(KP+0)*MA] := A[(II-1)+(KP+0)*MA]*PIV;
  for KK:=1 to K11 do
   begin
    if ( KK-1 <> KP ) 
     then A[(II-1)+(KK-1)*MA] := A[(II-1)+(KK-1)*MA]-A[(IP+0)+(KK-1)*MA]*A[(II-1)
     +(KP+0)*MA];
_10:
   end;
_20:
 end;
_30:
for KK:=1 to K11 do
 begin
  if ( KK-1 <> KP ) 
   then A[(IP+0)+(KK-1)*MA] := -A[(IP+0)+(KK-1)*MA]*PIV;
_40:
 end;
A[(IP+0)+(KP+0)*MA] := PIV;
end;

end.
